#!/bin/bash

packagesPath='/opt/compatibility_layer/config/install.list'
envList="ubuntu16.04 ubuntu18.04 ubuntu20.04 v10 v10sp1 openkylin1.0"

function _kare()
{
    local shortopts="-e -E -b -r -P -l --help"
    local longopts="install remove list run"
    local cur prev

    COMPREPLY=()
    fileopts="install|-i"
    containeropts="remove|run|-r|-P"
    envopts="-e|-b"

    cur="${COMP_WORDS[COMP_CWORD]}"
    prev="${COMP_WORDS[COMP_CWORD-1]}"

    if [[ ${prev} =~ ${fileopts} ]];then
        COMPREPLY=( $(compgen -W "`ls *.deb 2>/dev/null`" -- ${cur}) )
    elif [[ ${prev} =~ ${containeropts} ]];then
        packagelist=()
        for line in `cat ${packagesPath}`;do
            package=`echo ${line} | awk -F'=' '{print $1}'`
            packagelist[${#packagelist[*]}]=${package}
        done
        COMPREPLY=( $(compgen -W "`echo ${packagelist[@]}`" -- ${cur}) )
    elif [[ ${prev} =~ ${envopts} ]];then
        COMPREPLY=( $(compgen -W "${envList}" -- ${cur}) )
    elif [[ ${prev} == kare ]];then
        COMPREPLY=( $(compgen -W "${shortopts} ${longopts}" -- ${cur}) )
    elif [[ ${cur} == -* ]];then
        COMPREPLY=( $(compgen -W "${shortopts}" -- ${cur}) )
    fi
}

complete -F _kare kare