import os
import subprocess
import shutil
import argparse
import UpgradeCheck
from pathlib import Path


def parse_args():
    parser = argparse.ArgumentParser(description='Check if a package can run on a specific OS version')

    parser.add_argument("-d", type=str, required=False,help='deb name')
    parser.add_argument("-fsold", type=str, required=False, help='fsold-path')
    parser.add_argument('-l', "--level", help=argparse.SUPPRESS, type=str, required=False, choices=['debug', 'info'])
    return parser.parse_args()



def main():
    args = parse_args()
    if not args.level:
        args.level = "info"
    os.chroot(args.fsold)
    os.chdir("/")
    kcc = UpgradeCheck.Check(args.level, args.d, args.fsold)
    kcc.get_deb_info()
    kcc.depend_is_exist()


#sudo python3 main.py -baseos-path iso_path -deriveos-path iso_path
if __name__ == '__main__':
    main()