#!/bin/bash

function Maximum_password_days(){

	dir=$1
	if [ -z "$dir" ];then
		echo "请输入配置文件存放目录的路径"
	elif [ `test -e $dir/login.defs;echo $?` -ne 0 ];then
		echo "不存在$dir/login.defs文件"
		return 1
	fi

	if [ `cat $dir/login.defs |grep "PASS_MAX_DAYS"|awk '{print $1,$2}'| grep -v "^#" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
	
		s_value=`cat $dir/login.defs |grep "PASS_MAX_DAYS"|awk '{print $1,$2}'|grep -v "^#"|grep "PASS_MAX_DAYS"|tail -n 1|awk  '{print $2}'`
	fi

	if [ ! -z "$s_value" ];then
		if [ `cat /etc/login.defs |grep "PASS_MAX_DAYS"|awk '{print $1,$2}'| grep -v "^#" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
		
			line=`cat -n /etc/login.defs |grep "PASS_MAX_DAYS"|awk '{print $2,$1}'|grep -v "^#"|grep "PASS_MAX_DAYS"|tail -n 1|awk  '{print $2}'`
			setline=$(($line - 1))
			if [ $setline -eq 0 ];then
				sed -i "1 d" /etc/login.defs
				sed -i "1 a PASS_MAX_DAYS        $s_value" /etc/login.defs 
			else
				sed -i "$line d" /etc/login.defs
				sed -i "$setline a PASS_MAX_DAYS        $s_value" /etc/login.defs 
			fi
		else
			echo "PASS_MAX_DAYS        $s_value" >> /etc/login.defs
		fi
	else
		sed -i '/^PASS_MAX_DAYS*/d' /etc/login.defs
	fi

}

function Password_expiration_warning(){

	dir=$1
	if [ -z "$dir" ];then
		echo "请输入配置文件存放目录的路径"
	elif [ `test -e $dir/login.defs;echo $?` -ne 0 ];then
		echo "不存在$dir/login.defs文件"
		return 1
	fi

	if [ `cat $dir/login.defs |grep "PASS_WARN_AGE"|awk '{print $1,$2}'| grep -v "^#" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
	
		s_value=`cat $dir/login.defs |grep "PASS_WARN_AGE"|awk '{print $1,$2}'|grep -v "^#"|grep "PASS_WARN_AGE"|tail -n 1|awk  '{print $2}'`
	fi

	if [ ! -z "$s_value" ];then
		if [ `cat /etc/login.defs |grep "PASS_WARN_AGE"|awk '{print $1,$2}'| grep -v "^#" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
		
			line=`cat -n /etc/login.defs |grep "PASS_WARN_AGE"|awk '{print $2,$1}'|grep -v "^#"|grep "PASS_WARN_AGE"|tail -n 1|awk  '{print $2}'`
			setline=$(($line - 1))
			if [ $setline -eq 0 ];then
				sed -i "1 d" /etc/login.defs
				sed -i "1 a PASS_WARN_AGE        $s_value" /etc/login.defs 
			else
				sed -i "$line d" /etc/login.defs
				sed -i "$setline a PASS_WARN_AGE        $s_value" /etc/login.defs 
			fi
		else
			echo "PASS_WARN_AGE        $s_value" >> /etc/login.defs
		fi
	else
		sed -i '/^PASS_WARN_AGE*/d' /etc/login.defs
	fi

}

function Password_faillock_setting(){

	dir=$1
	if [ -z "$dir" ];then
		echo "请输入配置文件存放目录的路径"
	elif [ `test -e $dir/common-auth;echo $?` -ne 0 ];then
		echo "不存在$dir/common-auth文件"
		return 1
	fi

	string1=`cat $dir/common-auth|grep "unlock_time="|grep "deny="|awk '{print $1}'|grep -v "^#"`
	
	if [ -z "$string1" ];then
		sed -i 's/deny=.*//g' /etc/pam.d/common-auth
	else
		deny=`cat $dir/common-auth|grep "unlock_time="|grep "deny="|awk '{print $1 ,$0}'|grep -v "^#"|head -n 1|awk -F 'deny=' '{print $2}'|awk '{print $1}'`
		lock_time=`cat $dir/common-auth|grep "unlock_time="|grep "deny="|awk '{print $1 ,$0}'|grep -v "^#"|head -n 1|awk -F 'unlock_time=' '{print $2}'|awk '{print $1}'`

		string2=`cat /etc/pam.d/common-auth|grep "unlock_time="|grep "deny="|awk '{print $1}'|grep -v "^#"`
		if [ -z "$string2" ];then
	        	sed -i "/pam_unix.so/s/$/deny=5 unlock_time=180 root_unlock_time=180/g" /etc/pam.d/common-auth
		else
			sed -ri "s/(deny=)[^ ]*/\1$deny/" /etc/pam.d/common-auth
			sed -ri "s/(unlock_time=)[^ ]*/\1$lock_time/" /etc/pam.d/common-auth
		fi
	fi

}

p_dir=$1
if [ -z "$p_dir" ];then
	echo "请输入配置文件存放目录的路径"
	exit 0xFF01

elif [  ! -d $p_dir ];then
	echo "请输入正确的目录"
	exit 0xFF02
fi

file1=$p_dir/pwquality.conf

#cp $p_idr/pwquality.conf /etc/security/
cp $file1 /etc/security/
Password_faillock_setting $1
Maximum_password_days $1
Password_expiration_warning $1

echo "success"
